﻿if (select(2, UnitClass("player"))) ~= "ROGUE" then return end

local AceConfig = LibStub("AceConfigDialog-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Envenomous")

Envenomous = LibStub("AceAddon-3.0"):NewAddon("Envenomous", "AceEvent-3.0", "AceConsole-3.0")
local mod = Envenomous

local options
local optFrame
function mod:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("EnvenomousDB", nil, "Default")
	self.db:RegisterDefaults({
		profile = {
			modules = {},
		}
	})
	
	optFrame = AceConfig:AddToBlizOptions(L["Envenomous"], L["Envenomous"])
	self.configOptions = options
	LibStub("AceConfig-3.0"):RegisterOptionsTable(L["Envenomous"], options)
	self:RegisterChatCommand("Envenomous", self.ShowConfig)
	
	self:UnregisterAllEvents()
end

function mod:OnEnable()
	local fmt = "|cffffffff%s - |r|cff33ff99%s|r"
	
	local name, module
	for name, module in self:IterateModules() do
		options.args.modules.args[name] = {
			type = "toggle",
			name = fmt:format(L[name], L[name .. "_Desc"]),
			desc = L["Toggle %s"]:format(L[name]),
			width = "full",
			get = function(info)
				return self.db.profile.modules[name] ~= false or false
			end,
			set = function(info, v)
				self.db.profile.modules[name] = v
				if v then
					self:EnableModule(name)
				else
					self:DisableModule(name)
				end
			end
		}
	
		if not module:IsEnabled() and self.db.profile.modules[name] ~= false then
			self:EnableModule(name)
		end
	end
end

function mod:OnDisable()
	local name, module
	for name, module in self:IterateModules() do
		self:DisableModule(name)
	end
end

function mod:ShowConfig()
	AceConfig:SetDefaultSize(L["Envenomous"], 500, 550)
	AceConfig:Open(L["Envenomous"], configFrame)
end

do
	options = {
		type = "group",
		name = L["Envenomous"],
		desc = L["Tools to optimize the poison side of Mutilate."],
		childGroups = "tab",
		args = {
			config = {
				type = "execute",
				name = L["Configure"],
				desc = L["Open the configuration dialog"],
				func = Envenomous.ShowConfig,
				guiHidden = true
			},
			modules = {
				type = "group",
				name = L["Modules"],
				order = 0,
				args = {
				}
			},
		},
	}
	
	Envenomous.options = options
end